/* Problem URL: https://codeforces.com/problemset/problem/2112/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n;
    cin >> n;

    vvi graph(n);
    rep(i, n - 1) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    V<pair<int, int>> edges;
    pair<int, int> c1;
    pair<int, int> c2;
    int dc = -1;
    function<bool(int, int, int)> dfs = [&](int i, int p, int d) {
        bool valid = false;
        repv(j, graph[i]) {
            if (j == p) {
                continue;
            }

            valid = valid || graph[i].size() >= 2;

            if (d & 1) {
                edges.emplace_back(j + 1, i + 1);
            } else {
                edges.emplace_back(i + 1, j + 1);
            }

            if (dfs(j, i, d + 1 - valid) && dc == -1) {
                dc = d;
                c1 = {i + 1, j + 1};
                c2 = {j + 1, graph[j][0] == i ? graph[j][1] + 1 : graph[j][0] + 1};
                // edges.pop_back();
                edges.pop_back();
                edges.pop_back();
            }
        }

        return valid;
    };

    dfs(0, 0, 0);
    if (dc == -1) {
        edges.clear();
        dfs(n - 1, n - 1, 0);
        if (dc == -1) {
            edges.clear();
            dfs(n - 2, n - 2, 0);
            if (dc == -1) {
                edges.clear();
                dfs(1, 1, 0);
                if (dc == -1) {
                    cout << "NO\n";
                    return;
                }
            }
        }
    }

    cout << "YES\n";

    if (dc & 1) {
        repv(i, edges) {
            swap(i.first, i.second);
        }
    }

    repv(i, edges) {
        cout << i.first << ' ' << i.second << '\n';
    }
    cout << c1.first << ' ' << c1.second << '\n';
    cout << c2.first << ' ' << c2.second << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
